// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rai_interfaces:srv/EmbodimentInfo.idl
// generated code does not contain a copyright notice

#ifndef RAI_INTERFACES__SRV__DETAIL__EMBODIMENT_INFO__STRUCT_HPP_
#define RAI_INTERFACES__SRV__DETAIL__EMBODIMENT_INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__rai_interfaces__srv__EmbodimentInfo_Request __attribute__((deprecated))
#else
# define DEPRECATED__rai_interfaces__srv__EmbodimentInfo_Request __declspec(deprecated)
#endif

namespace rai_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct EmbodimentInfo_Request_
{
  using Type = EmbodimentInfo_Request_<ContainerAllocator>;

  explicit EmbodimentInfo_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit EmbodimentInfo_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    rai_interfaces::srv::EmbodimentInfo_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rai_interfaces::srv::EmbodimentInfo_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rai_interfaces::srv::EmbodimentInfo_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rai_interfaces::srv::EmbodimentInfo_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::EmbodimentInfo_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::EmbodimentInfo_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::EmbodimentInfo_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::EmbodimentInfo_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rai_interfaces::srv::EmbodimentInfo_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rai_interfaces::srv::EmbodimentInfo_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rai_interfaces__srv__EmbodimentInfo_Request
    std::shared_ptr<rai_interfaces::srv::EmbodimentInfo_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rai_interfaces__srv__EmbodimentInfo_Request
    std::shared_ptr<rai_interfaces::srv::EmbodimentInfo_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EmbodimentInfo_Request_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const EmbodimentInfo_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EmbodimentInfo_Request_

// alias to use template instance with default allocator
using EmbodimentInfo_Request =
  rai_interfaces::srv::EmbodimentInfo_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rai_interfaces


#ifndef _WIN32
# define DEPRECATED__rai_interfaces__srv__EmbodimentInfo_Response __attribute__((deprecated))
#else
# define DEPRECATED__rai_interfaces__srv__EmbodimentInfo_Response __declspec(deprecated)
#endif

namespace rai_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct EmbodimentInfo_Response_
{
  using Type = EmbodimentInfo_Response_<ContainerAllocator>;

  explicit EmbodimentInfo_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->description = "";
    }
  }

  explicit EmbodimentInfo_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : description(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->description = "";
    }
  }

  // field types and members
  using _rules_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>>;
  _rules_type rules;
  using _capabilities_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>>;
  _capabilities_type capabilities;
  using _behaviors_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>>;
  _behaviors_type behaviors;
  using _description_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _description_type description;
  using _images_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>>;
  _images_type images;

  // setters for named parameter idiom
  Type & set__rules(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>> & _arg)
  {
    this->rules = _arg;
    return *this;
  }
  Type & set__capabilities(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>> & _arg)
  {
    this->capabilities = _arg;
    return *this;
  }
  Type & set__behaviors(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>> & _arg)
  {
    this->behaviors = _arg;
    return *this;
  }
  Type & set__description(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->description = _arg;
    return *this;
  }
  Type & set__images(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>> & _arg)
  {
    this->images = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rai_interfaces::srv::EmbodimentInfo_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rai_interfaces::srv::EmbodimentInfo_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rai_interfaces::srv::EmbodimentInfo_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rai_interfaces::srv::EmbodimentInfo_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::EmbodimentInfo_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::EmbodimentInfo_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rai_interfaces::srv::EmbodimentInfo_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rai_interfaces::srv::EmbodimentInfo_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rai_interfaces::srv::EmbodimentInfo_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rai_interfaces::srv::EmbodimentInfo_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rai_interfaces__srv__EmbodimentInfo_Response
    std::shared_ptr<rai_interfaces::srv::EmbodimentInfo_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rai_interfaces__srv__EmbodimentInfo_Response
    std::shared_ptr<rai_interfaces::srv::EmbodimentInfo_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EmbodimentInfo_Response_ & other) const
  {
    if (this->rules != other.rules) {
      return false;
    }
    if (this->capabilities != other.capabilities) {
      return false;
    }
    if (this->behaviors != other.behaviors) {
      return false;
    }
    if (this->description != other.description) {
      return false;
    }
    if (this->images != other.images) {
      return false;
    }
    return true;
  }
  bool operator!=(const EmbodimentInfo_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EmbodimentInfo_Response_

// alias to use template instance with default allocator
using EmbodimentInfo_Response =
  rai_interfaces::srv::EmbodimentInfo_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rai_interfaces

namespace rai_interfaces
{

namespace srv
{

struct EmbodimentInfo
{
  using Request = rai_interfaces::srv::EmbodimentInfo_Request;
  using Response = rai_interfaces::srv::EmbodimentInfo_Response;
};

}  // namespace srv

}  // namespace rai_interfaces

#endif  // RAI_INTERFACES__SRV__DETAIL__EMBODIMENT_INFO__STRUCT_HPP_
